      program convolution
!main program to test
!Flatau, P. J. Fast solvers for one dimensional light scattering 
!in the discrete dipole approximation, 
!Optics Express , 12 , 3149-3155, 2004.
      integer nx
      complex, dimension(:), allocatable:: tcol,trow,bcol,brow,x,y,xsi
      complex, dimension(:), allocatable:: ycirc, yskew, ytot
      complex, dimension(:), allocatable:: ab1, ab2, ab3, ab4
      complex, dimension(:), allocatable:: x2, tb2, y2a, y2b
      complex, dimension(:,:), allocatable:: toep, barr, circ
      complex, dimension(:,:), allocatable:: circ2, toep_sym, toep_asym
      complex, dimension(:,:), allocatable:: add
      character*100 cline
      call getarg(1, cline)
      read(cline,*) nx
      nx2=2*nx
      allocate (tcol(nx),trow(nx),bcol(nx),brow(nx),x(nx),y(nx),xsi(nx))
      allocate (ycirc(nx), yskew(nx), ytot(nx))
      allocate (ab1(nx), ab2(nx), ab3(nx), ab4(nx))
      allocate (circ(nx,nx), toep(nx,nx), barr(nx,nx))
      allocate (toep_sym(nx,nx), toep_asym(nx,nx), add(nx,nx))
      allocate (circ2(nx2,nx2))
      allocate (x2(nx2), tb2(nx2), y2a(nx2), y2b(nx2))
!
      call gen1(tcol,trow,nx)
!      call doxsi(xsi,1.,0.,nx)
!      call phi_circulant(circ,tcol,nx,phi)
      

      call gentoep(toep,tcol,trow,nx)
! generate row and column of B matrix
      call gen2(tcol,trow, bcol, brow, nx)
      call gentoep(barr,bcol, brow,nx)
!test 
      ab1=tcol+bcol
      ab2=trow+brow
      ab3=tcol-bcol
      ab4=trow-brow

      call phi_circulant(circ,ab1,nx,1.)
      call phi_circulant(barr,ab3,nx,-1.)

      do i=1,nx
        write(6,*) real(circ(i,:))
      enddo 
       print*, ' -- '
      do i=1,nx
        write(6,*) real(barr(i,:))
      enddo

          

!
!!      call gentoep(toep_sym,ab1, ab2,nx)
!!      call gentoep(toep_asym,ab3,ab4,nx)
!
      x(1:nx)=cmplx(1.,0.)

      do i=1,nx
       x(i)=cmplx(rand(),rand())
      enddo

      y(1:nx)=matmul(toep,x)
     
! test Eq 16 (toeplitz matrix time vector using circulant and skew-circulant)
! Flatau, P. J. Fast solvers for one dimensional light scattering in the 
! discrete dipole approximation, 
! Optics Express , 12 , 3149-3155, 2004.

      call circmult(bcol,x,nx,ycirc)   
      call skewmult(brow,x,nx,yskew)   

!      call skewmult(ab1,x,nx,yskew)
      ytot=1./2.*(ycirc+yskew)
      do i=1,nx
            print*,  i, ycirc(i), yskew(i), ytot(i)
      enddo
!

      call circmult(ab1,x,nx,ycirc)   
      call skewmult(ab3,x,nx,yskew)
      ytot=1./2.*(ycirc+yskew)
      do i=1,nx
            print*,  i, ycirc(i), yskew(i), ytot(i)
      enddo


      stop



      circ2=cmplx(10.,10.)
      circ2(1:nx,1:nx)=toep
      circ2(nx+1:2*nx,1:nx)=barr
      circ2(1:nx,nx+1:2*nx)=barr
      circ2(nx+1:2*nx, nx+1:2*nx) = toep

      x2=x
      x2(nx+1:2*nx)=cmplx(0.,0.)
!generate circulant
      tb2(1:nx)=tcol
      tb2(nx+1:2*nx)=bcol
! now we can test various algorithms
      call mult1(circ2,x2,nx2,y2a)

!symmetric/antysymmetric
     

      call circmult(tb2,x2,nx2, y2b)
      print*, y2a-y2b
      stop
      end



      subroutine doxsi(xsi, x,y,n)
!generate vector D of phi-circulant (a.k.a omega circulant)
!see equation 13 in 
!Flatau, P. J. Fast solvers for one dimensional light scattering in the 
!discrete dipole approximation, Optics Express , 12 , 3149-3155, 2004.
!I am not sure this is OK, not used
      complex xsi(n), ci
      ci=cmplx(0.,1.)          
      phi=atan2(y,x)
      r=sqrt(x**2+y**2)
      pi=4.*atan(1.)
      print*, pi
      print*, x, y, r, phi
! z = r exp(i phi)
! sqrt(z,n)  = sqrt(r,n)  exp(i (phi+2 k pi) / n) k=0, 1, ..., n-1
      do k=0, n-1
        xsi(k+1)= r**(1./real(n)) * exp (ci*(phi+2.*k * pi)/real(n))       
      enddo
      print*, xsi
      return
      end

      subroutine phi_circulant(circ,col,n,phi)
! equation 12 in
! Flatau, P. J. Fast solvers for one dimensional light scattering in the 
! discrete dipole approximation, Optics Express , 12 , 3149-3155, 2004.
      complex circ(n,n), col(n)
      do i=1, n
       do j=i,n
        circ(i,j)=phi*col(n-j+i+1)
       enddo
      enddo
!assign lower triangular
      do j=1,n
        do i=j,n
        circ(i,j)=col(i-j+1)
        enddo
      enddo
      
      return
      end

      subroutine mult1(circ2, x2, n2, y2a)
      complex circ2(n2,n2), x2(n2), y2a(n2)
      y2a=matmul(circ2,x2)
      return
      end

      subroutine circmult(circ,x,n,y)
! This code calculates y = circ x  for matrix (expressed here by its column)
! which is circulant
! On input: circ - vector describing circulat matrix, x known vector
! On output: y
      complex circ(n), x(n), y(n)
      complex circ_local(n), x_local(n)
!FFT multiplication
!warning x, tb are done in-place (i.e. the are overwritten)
      x_local=x
      circ_local=circ
      call cxfft3n(x_local,n,1,1,+1)
      call cxfft3n(circ_local,n,1,1,+1)
      y=x_local*circ_local
      call cxfft3n(y,n,1,1,-1)
      y=y/real(n)
      return
      end

      subroutine skewmult(skew,x,n,y)
! This code calculates y = skew x
! On input: skew - vector describing skew-circulant matrix, x - known vector
! On ouput: y
! V. Y. Pan, Structured Matrices and Polynomials: Unified Superfast Algorithms,
! 2001, Springer, ISBN 0817642404
! There seems to be an error in Pan's algorithm -
! x needs to be also multiplied by omega

      complex skew(n), x(n), y(n)
      complex omega(n), const
      complex skew_local(n), x_local(n)
      skew_local=skew
      x_local=x
      pi=4.*atan(1.)
      const=exp(cmplx(0.,1.)*pi/real(n))

      do i=0,n-1
       omega(i+1)=const**i
      enddo

      print*,' const ', const
      print*,' omega ', omega
      print*, ' x ', x

      x_local=x_local*omega
      skew_local=skew_local*omega
!
      call cxfft3n(x_local,n,1,1,+1)
      call cxfft3n(skew_local,n,1,1,+1)
      y=x_local*skew_local
      call cxfft3n(y,n,1,1,-1)
      y=y/omega
      y=y/real(n)
      return
      end

      subroutine gen2(tcol,trow, bcol, brow, n)
! for known tcol, trow describing Toeplitz matrix T define 
! matrix B as in 
! http://www.cs.utk.edu/~dongarra/etemplates/node384.html
      integer n, i
      complex tcol(n), trow(n), bcol(n), brow(n)      
      bcol(1)=cmplx(0.,0.)
      brow(1)=cmplx(0.,0.)
      do i=2,n  
        bcol(i)=trow(n-i+2)
        brow(i)=tcol(n-i+2)
      enddo
      return
      end
       
      subroutine gen1(col, row,n)
!define col and row of a toeplitz matrix
! notation follows
! http://www.cs.utk.edu/~dongarra/etemplates/node384.html
      implicit none
      integer n, i
      complex col(n), row(n)      
      do i=1,n
        col(i)=cmplx(i**2-1,0.)
!       row(i)=-cmplx(i**2-1,0.)
       row(i)= col(i)

!make it symmetric         col(i)=cmplx(rand(),rand())
!         row(i)=col(i)

      enddo

      return
      end

      subroutine gentoep(toep,col,row,n)
!generate nxn toeplitz matrix knowing its col and row vectors
      implicit none
      integer n, i, j
      complex toep(n,n)
      complex col(n), row(n)
!assign upper triangular
      do i=1, n
       do j=i,n
        toep(i,j)=row(j-i+1)
       enddo
      enddo
!assign lower triangular
      do j=1,n
        do i=j,n
        toep(i,j)=col(i-j+1)
        enddo
      enddo
      return
      end